| Flutter Impeller |

Public Member Functions | List of all members
impeller::LinearGradientContents Class Referencefinal

`#include <linear_gradient_contents.h>`

Inheritance diagram for impeller::LinearGradientContents:

## Public Member Functions
| LinearGradientContents ()
| ~LinearGradientContents () override
bool | IsOpaque (const Matrix &transform) const override
| Whether this Contents only emits opaque source colors from the fragment stage. This value does not account for any entity properties (e.g. the blend mode), clips/visibility culling, or inherited opacity. More...
bool | Render (const ContentContext &renderer, const Entity &entity, RenderPass &pass) const override
bool | ApplyColorFilter (const ColorFilterProc &color_filter_proc) override
| If possible, applies a color filter to this contents inputs on the CPU. More...
void | SetEndPoints (Point start_point, Point end_point)
void | SetColors (std::vector< Color > colors)
void | SetStops (std::vector< Scalar > stops)
const std::vector< Color > & | GetColors () const
const std::vector< Scalar > & | GetStops () const
void | SetTileMode (Entity::TileMode tile_mode)
Public Member Functions inherited from impeller::ColorSourceContents
| ColorSourceContents ()
| ~ColorSourceContents () override
void | SetGeometry (const Geometry *geometry)
| Set the geometry that this contents will use to render. More...
const Geometry * | GetGeometry () const
| Get the geometry that this contents will use to render. More...
void | SetEffectTransform (Matrix matrix)
| Set the effect transform for this color source. More...
const Matrix & | GetInverseEffectTransform () const
| Set the inverted effect transform for this color source. More...
void | SetOpacityFactor (Scalar opacity)
| Set the opacity factor for this color source. More...
Scalar | GetOpacityFactor () const
| Get the opacity factor for this color source. More...
virtual bool | IsSolidColor () const
std::optional< Rect > | GetCoverage (const Entity &entity) const override
| Get the area of the render pass that will be affected when this contents is rendered. More...
void | SetInheritedOpacity (Scalar opacity) override
| Inherit the provided opacity. More...
Public Member Functions inherited from impeller::Contents
| Contents ()
virtual | ~Contents ()
void | SetCoverageHint (std::optional< Rect > coverage_hint)
| Hint that specifies the coverage area of this Contents that will actually be used during rendering. This is for optimization purposes only and can not be relied on as a clip. May optionally affect the result of `GetCoverage()`. More...
const std::optional< Rect > & | GetCoverageHint () const
virtual std::optional< Snapshot > | RenderToSnapshot (const ContentContext &renderer, const Entity &entity, std::optional< Rect > coverage_limit=std::nullopt, const std::optional< SamplerDescriptor > &sampler_descriptor=std::nullopt, bool msaa_enabled=true, int32_t mip_count=1, std::string_view label="Snapshot") const
| Render this contents to a snapshot, respecting the entity's transform, path, clip depth, and blend mode. The result texture size is always the size of `GetCoverage(entity)`. More...
std::optional< Size > | GetColorSourceSize () const
| Return the color source's intrinsic size, if available. More...
void | SetColorSourceSize (Size size)
virtual std::optional< Color > | AsBackgroundColor (const Entity &entity, ISize target_size) const
| Returns a color if this Contents will flood the given `target_size` with a color. This output color is the "Source" color that will be used for the Entity's blend operation. More...

## Additional Inherited Members
Public Types inherited from impeller::ColorSourceContents
using | BindFragmentCallback = std::function< bool(RenderPass &pass)>
using | PipelineBuilderCallback = std::function< PipelineRef(ContentContextOptions)>
using | CreateGeometryCallback = std::function< GeometryResult(const ContentContext &renderer, const Entity &entity, RenderPass &pass, const Geometry *geom)>
Public Types inherited from impeller::Contents
using | ColorFilterProc = std::function< Color(Color)>
using | RenderProc = std::function< bool(const ContentContext &renderer, const Entity &entity, RenderPass &pass)>
using | CoverageProc = std::function< std::optional< Rect >(const Entity &entity)>
Static Public Member Functions inherited from impeller::ColorSourceContents
template<typename VertexShaderT >
static bool | DrawGeometry (const Contents *contents, const Geometry *geometry, const ContentContext &renderer, const Entity &entity, RenderPass &pass, const PipelineBuilderCallback &pipeline_callback, typename VertexShaderT::FrameInfo frame_info, const BindFragmentCallback &bind_fragment_callback, bool force_stencil=false, const CreateGeometryCallback &create_geom_callback=DefaultCreateGeometryCallback)
Static Public Member Functions inherited from impeller::Contents
static std::shared_ptr< Contents > | MakeAnonymous (RenderProc render_proc, CoverageProc coverage_proc)
Protected Member Functions inherited from impeller::ColorSourceContents
bool | AppliesAlphaForStrokeCoverage (const Matrix &transform) const
| Whether the entity should be treated as non-opaque due to stroke geometry requiring alpha for coverage. More...
template<typename VertexShaderT >
bool | DrawGeometry (const ContentContext &renderer, const Entity &entity, RenderPass &pass, const PipelineBuilderCallback &pipeline_callback, typename VertexShaderT::FrameInfo frame_info, const BindFragmentCallback &bind_fragment_callback, bool force_stencil=false, const CreateGeometryCallback &create_geom_callback=DefaultCreateGeometryCallback) const
Static Protected Member Functions inherited from impeller::ColorSourceContents
static GeometryResult | DefaultCreateGeometryCallback (const ContentContext &renderer, const Entity &entity, RenderPass &pass, const Geometry *geom)

## Detailed Description

Definition at line 17 of file linear_gradient_contents.h.

## Constructor & Destructor Documentation

## ◆ LinearGradientContents()

impeller::LinearGradientContents::LinearGradientContents | ( |  | ) |
| default

## ◆ ~LinearGradientContents()

impeller::LinearGradientContents::~LinearGradientContents | ( |  | ) |
| overridedefault

## Member Function Documentation

## ◆ ApplyColorFilter()

bool impeller::LinearGradientContents::ApplyColorFilter | ( | const ColorFilterProc & | color_filter_proc | ) |
| overridevirtual

If possible, applies a color filter to this contents inputs on the CPU.

This method will either fully apply the color filter or perform no action. Partial/incorrect application of the color filter will never occur.

Parameters

  [in] | color_filter_proc | A function that filters a given unpremultiplied color to produce a new unpremultiplied color.

Returns
  True if the color filter was able to be fully applied to all all relevant inputs. Otherwise, this operation is a no-op and false is returned.

Reimplemented from impeller::Contents.

Definition at line 363 of file linear_gradient_contents.cc.

364 {
365 for (Color& color : colors_) {
366 color = color_filter_proc(color);
367 }
368 decal_border_color_ = color_filter_proc(decal_border_color_);
369 return true;
370 }

## ◆ GetColors()

const std::vector< Color > & impeller::LinearGradientContents::GetColors | ( |  | ) | const

Definition at line 35 of file linear_gradient_contents.cc.

35 {
36 return colors_;
37 }

## ◆ GetStops()

const std::vector< Scalar > & impeller::LinearGradientContents::GetStops | ( |  | ) | const

Definition at line 39 of file linear_gradient_contents.cc.

39 {
40 return stops_;
41 }

## ◆ IsOpaque()

bool impeller::LinearGradientContents::IsOpaque | ( | const Matrix & | transform | ) | const
| overridevirtual

Whether this Contents only emits opaque source colors from the fragment stage. This value does not account for any entity properties (e.g. the blend mode), clips/visibility culling, or inherited opacity.

Parameters

  transform | The current transform matrix of the entity that will render this contents.

Reimplemented from impeller::Contents.

Definition at line 47 of file linear_gradient_contents.cc.

47 {
48 if (GetOpacityFactor() < 1 || tile_mode_ == Entity::TileMode::kDecal) {
49 return false;
50 }
51 for (auto color : colors_) {
52 if (!color.IsOpaque()) {
53 return false;
54 }
55 }
56 return !AppliesAlphaForStrokeCoverage(transform);
57 }
impeller::ColorSourceContents::GetOpacityFactor
Scalar GetOpacityFactor() const
Get the opacity factor for this color source.
Definition: color_source_contents.cc:28
impeller::ColorSourceContents::AppliesAlphaForStrokeCoverage
bool AppliesAlphaForStrokeCoverage(const Matrix &transform) const
Whether the entity should be treated as non-opaque due to stroke geometry requiring alpha for coverag...
Definition: color_source_contents.cc:53
impeller::Entity::TileMode::kDecal
@ kDecal
transform
Matrix transform
Definition: gaussian_blur_filter_contents.cc:214

References impeller::ColorSourceContents::AppliesAlphaForStrokeCoverage(), impeller::ColorSourceContents::GetOpacityFactor(), impeller::Entity::kDecal, and transform.

Referenced by impeller::testing::TEST_P().

## ◆ Render()

bool impeller::LinearGradientContents::Render | ( | const ContentContext & | renderer,
|  | const Entity & | entity,
|  | RenderPass & | pass
| ) |  | const
| overridevirtual

Implements impeller::Contents.

Definition at line 197 of file linear_gradient_contents.cc.

199 {
200 // TODO(148651): The fast path is overly restrictive, following the design in
201 // https://github.com/flutter/flutter/issues/148651 support for more cases can
202 // be gradually added.
203 if (CanApplyFastGradient()) {
204 return FastLinearGradient(renderer, entity, pass);
205 }
206 if (renderer.GetDeviceCapabilities().SupportsSSBO()) {
207 return RenderSSBO(renderer, entity, pass);
208 }
209 if (colors_.size() <= kMaxUniformGradientStops &&
210 stops_.size() <= kMaxUniformGradientStops) {
211 return RenderUniform(renderer, entity, pass);
212 }
213 return RenderTexture(renderer, entity, pass);
214 }
impeller::kMaxUniformGradientStops
static constexpr uint32_t kMaxUniformGradientStops
Definition: gradient_generator.h:47

References impeller::ContentContext::GetDeviceCapabilities(), impeller::kMaxUniformGradientStops, and impeller::Capabilities::SupportsSSBO().

## ◆ SetColors()

void impeller::LinearGradientContents::SetColors | ( | std::vector< Color > | colors | ) |

Definition at line 27 of file linear_gradient_contents.cc.

27 {
28 colors_ = std::move(colors);
29 }

Referenced by impeller::testing::TEST_P().

## ◆ SetEndPoints()

void impeller::LinearGradientContents::SetEndPoints | ( | Point | start_point,
|  | Point | end_point
| ) |  |

Definition at line 22 of file linear_gradient_contents.cc.

22 {
23 start_point_ = start_point;
24 end_point_ = end_point;
25 }

## ◆ SetStops()

void impeller::LinearGradientContents::SetStops | ( | std::vector< Scalar > | stops | ) |

Definition at line 31 of file linear_gradient_contents.cc.

31 {
32 stops_ = std::move(stops);
33 }

## ◆ SetTileMode()

void impeller::LinearGradientContents::SetTileMode | ( | Entity::TileMode | tile_mode | ) |

Definition at line 43 of file linear_gradient_contents.cc.

43 {
44 tile_mode_ = tile_mode;
45 }

Referenced by impeller::testing::TEST_P().

The documentation for this class was generated from the following files:

- impeller/entity/contents/linear_gradient_contents.h
- impeller/entity/contents/linear_gradient_contents.cc